import { Subscriber } from '../Subscriber';
export class OperatorSubscriber extends Subscriber {
    constructor(destination, onNext, onError, onComplete, onUnsubscribe) {
        super(destination);
        this.onUnsubscribe = onUnsubscribe;
        this._next = onNext
            ? function (value) {
                try {
                    onNext(value);
                }
                catch (err) {
                    this.destination.error(err);
                }
            }
            : super._next;
        this._error = onError
            ? function (err) {
                try {
                    onError(err);
                }
                catch (err) {
                    this.destination.error(err);
                }
                this.unsubscribe();
            }
            : super._error;
        this._complete = onComplete
            ? function () {
                try {
                    onComplete();
                }
                catch (err) {
                    this.destination.error(err);
                }
                this.unsubscribe();
            }
            : super._complete;
    }
    unsubscribe() {
        var _a;
        !this.closed && ((_a = this.onUnsubscribe) === null || _a === void 0 ? void 0 : _a.call(this));
        super.unsubscribe();
    }
}
//# sourceMappingURL=OperatorSubscriber.js.map